var Display = {
    statusDiv : null,
    FIRSTIDX : 0,
    LASTIDX : 4,
    currentWindow : 0,    
    videoList : new Array()
};

Display.init = function() {
    var success = true;
    this.statusDiv = document.getElementById('status');
    if (!this.statusDiv) {
        success = false;
    }
    return success;
};

Display.setTotalTime = function(total) {
    this.totalTime = total;
  };

Display.msToTime = function(ms) {
    var time = parseInt(ms / 1000, 10);
    var seconds = time % 60;
    var minutes = parseInt((time % 3600) / 60, 10);
    var hours = parseInt(time / 3600, 10);
    if (seconds < 10) {
        seconds = '0' + seconds;
    }
    if (minutes < 10) {
        minutes = '0' + minutes;
    }
    return hours + ':' + minutes + ':' + seconds;
};

Display.setTime = function(time) {
if (Main.mode == Main.FULLSCREEN && Player.state == Player.PLAYING)
Main.count_time=0;
if (Data.videoType && Data.videoType[Main.selectedVideo]  == "radio") {
//$('#timeInfo').text(LIVE);
 return;
}
    if (time == 0) {
        $('#progressBar').width(0);
    } else {
        var timePercent = (100 * time) / this.totalTime;
        $('#progressBar').width(timePercent + '%');
    }
      if (Player.state == Player.PLAYING || Player.state == Player.PAUSED) {
        $('#timeInfo').text(Display.msToTime(time) + '/' + Display.msToTime(this.totalTime));
    } else {
        $('#timeInfo').text('0:00:00/0:00:00');
    }
    Player.cur_time=time;
};

Display.status = function(status) {
    alert(status);
    widgetAPI.putInnerHTML(this.statusDiv, status);
};

Display.setVolume = function(level) {
    $('#volumeBar').width(level + '%');
};


Display.setVideoList = function(nameList) {
    var i = 0;
     while (i < nameList.length) {
        var img_type = 'Images/audio.png';
        if (Data.videoType[i] == 'video') {
            img_type = 'Images/video.png';
        } else if (Data.videoType[i] == 'radio') {
        img_type = 'Images/radio.png';
        }
        $('#videoList').append('<li class="list_item" id="video' + i + '"><img class="img_type" src="' + img_type + '">' + Data.videoNamesNoTruncate[i] + '</li>');
        i++;
    }
    if (i > 5) {
        $('#next').css('opacity',  1.0);
    }
    $('#videoCount').text('1 / ' + i);
    $('#listLoading').hide();
};

Display.setCurrent = function(position) {
    var i = 0;
   if(Data.videoType && Data.videoType[Main.selectedVideo]  == "radio") 
     $('#timeInfo').text(LIVE);
    else
       $('#timeInfo').text('0:00:00/0:00:00');
    while (i < Data.getVideoCount()) {
        $('#video' + i).css({
            color: '#FFF',
            backgroundImage: 'none'
        });
        i++;
    }
    $('#video' + position).css({
        color: '#FF7F00',
        backgroundImage: 'url("Images/current.png")'
    });
};

Display.setVideoListPosition = function(position, move) {
    $('#videoCount').text((position + 1) + ' / ' + Data.getVideoCount());
    
    if (move == Main.DOWN) {
        this.currentWindow++;
        if (position > Display.LASTIDX) {
            $('#videoList').animate({ top: '-=75px'}, 500, 'swing', Display.setCurrent(position));
            Display.FIRSTIDX++;
            Display.LASTIDX++;
            $('#previous').css('opacity', 1.0);
        } else {
            Display.setCurrent(position);
        }
    } else if (move == Main.UP) {
        this.currentWindow--;
        if (position < Display.FIRSTIDX) {
            $('#videoList').animate({ top: '+=75px'}, 500, 'swing', Display.setCurrent(position));
            Display.FIRSTIDX--;
            Display.LASTIDX--;
            $('#next').css('opacity', 1.0);
        } else {
            Display.setCurrent(position);
        }
    }
};

Display.setDescription = function(description) {
    $('#description').empty().append('<h2>' + Data.videoNamesNoTruncate[Main.selectedVideo] + '</h2><h3>' + Data.videoAuthor[Main.selectedVideo] + '</h3><p>' + description + '</p>');
    $('#itemThumbnail img').attr('src', Data.videoThumbnail[Main.selectedVideo]);
    $('#itemThumbnail').show();
};

Display.hide = function() {
    $('#main').hide();
    $('#header').hide();
};
Display.show = function() {
    $('#main').show();
    $('#header').show();
};
Display.showLogin = function() {
    Main.list=0;
    Main.error=0;
    $('#main').hide();
    $('#login_page').show();
};
Display.showMain = function() {
    $('#login_page').hide();
    $('#main').show();
};
Display.openPopup = function(type) {
    switch (type) {
        case 'buffer':
           $('#popupMsg').text(ERROR_BUFFERING);
            break;
        case 'network':
          $('#popupMsg').text(ERROR_NETWORK);
          break;
    }
    $('#popup').show();
};
Display.closePopup = function() {
    $('#popupMsg').text();
    $('#popup').hide();
};
