var Player = {
    plugin: null,
    state: -1,
    skipState: -1,
    stopCallback: null,    /* Callback function to be set by client */
    originalSource: null,
    stop_cmd: 1,
    STOPPED: 0,
    PLAYING: 1,
    PAUSED: 2,  
    FORWARD: 3,
    REWIND: 4,
    currentTime: 0
};


Player.init = function() {
    var success = true;
    this.state = this.STOPPED;
    this.plugin = document.getElementById('pluginPlayer');
    if (!this.plugin) {
        success = false;
    } else {
        var mwPlugin = document.getElementById('pluginObjectTVMW');
        if (!mwPlugin) {
            success = false;
        } else {
            /* Save current TV Source */
         //  this.originalSource = mwPlugin.GetSource();
            /* Set TV source to media player plugin */
            //mwPlugin.SetMediaSource();
        }
    }
    
    this.setWindow();
    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.setTotalTime';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete'; 
    // Errori
    this.plugin.OnStreamNotFound = 'Player.Error';
    this.plugin.OnConnectionFailed = 'Player.Error';
    this.plugin.OnRenderError = 'Player.Error';
    this.plugin.OnNetworkDisconnected = 'Player.Error';
    
    return success;
};

Player.deinit = function() {
  var mwPlugin = document.getElementById('pluginObjectTVMW');
    if (mwPlugin && (this.originalSource != null)) {
        /* Restore original TV source before closing the widget */
   //    mwPlugin.SetSource(this.originalSource);
       //alert("Restore source to " + this.originalSource);
    }
};

Player.setWindow = function() {
  if(Data.videoType[Main.selectedVideo] == 'video') {
      this.plugin.SetDisplayArea(471, 62, 445, 250);
       if(Player.state == 2) {
         Player.state=1;
         //setTimeout(Main.handlePauseKey,10);
         Main.handlePauseKey();
      }
    } else {
        this.plugin.SetDisplayArea(0, 0, 0, 0);
    }
};

Player.setFullscreen = function() {
  this.plugin.SetDisplayArea(0, 0, 960, 540);
   if( Player.state == 2) {
        Player.state=1;
       //setTimeout(Main.handlePauseKey,10);
       Main.handlePauseKey();
      }
   };

Player.setVideoURL = function(url) {
    this.url = url;
    alert('URL = ' + this.url);
};

Player.playVideo = function() {
   Player.skipState=-1;
    if (this.url == null) {
        alert('No videos to play');
    } else {
        this.state = this.PLAYING;
        this.setWindow();
        $('#play').css('opacity', 0.4);
        $('#stop').css('opacity', 1.0);
        $('#pause').css('opacity', 1.0);
        $('#forward').css('opacity', 1.0);
        $('#rewind').css('opacity', 1.0);
        Server.dolog(Main.username_dec, 'PLAY', Data.videoURLs[Main.selectedVideo], Data.videoSource[Main.selectedVideo]);
        Display.status('Playing');
          if (Data.videoType[Main.selectedVideo] == 'video') {
            $('#fullscreen').css('display', 'inline-block');
            $('#itemThumbnail img').attr('src', '');
            $('#itemThumbnail').hide();
        }
         
        $('#delete_element').hide();
        $('#refresh').hide();
        var position=0;
        if (Data.videoPosition[Main.selectedVideo] > 5)
         position=Data.videoPosition[Main.selectedVideo]-5;
         if(Main.guest == "" &&  position && position>0 && (Data.videoType[Main.selectedVideo] == 'video' || Data.videoType[Main.selectedVideo] == 'audio')) {
           alert("Play video at position "+position);
          this.plugin.ResumePlay( this.url,position );
         } 
         else
         this.plugin.Play( this.url );
         //Audio.plugin.SetSystemMute(false);
    }
};

Player.pauseVideo = function() {
    Player.skipState=-1;
     Main.itemLoadingHide();
    Server.dolog(Main.username_dec, 'PAUSE', Data.videoURLs[Main.selectedVideo], Data.videoSource[Main.selectedVideo]);
    clearInterval(Main.interval_buffer);
    this.state = this.PAUSED;
    $('#play').css('opacity', 1.0);
    $('#stop').css('opacity', 1.0);
    $('#pause').css('opacity', 0.4);
    $('#forward').css('opacity', 0.4);
    $('#rewind').css('opacity', 0.4);
    Display.status('Paused');
    this.plugin.Pause();
    };

Player.stopVideo = function() {
    Player.skipState=-1;
    Player.stop_cmd=1;
    Display.status('Stopped');
    $('#progressBar').width(0);
    clearInterval(Main.interval_buffer);
    $('#itemThumbnail img').attr('src', Data.videoThumbnail[Main.selectedVideo]);
    $('#itemThumbnail').show();
    Main.itemLoadingHide();
    if (this.state != this.STOPPED) {
        Server.dolog(Main.username_dec,'STOP', Data.videoURLs[Main.selectedVideo], Data.videoSource[Main.selectedVideo]);
        $('#fullscreen').hide();
        this.state = this.STOPPED;
        $('#play').css('opacity', 1.0);
        $('#stop').css('opacity', 0.4);
        $('#pause').css('opacity', 0.4);
        $('#forward').css('opacity', 0.4);
        $('#rewind').css('opacity', 0.4);
        Display.status('Stopped');
        $('#refresh').css('display', 'inline-block');
        if(!Main.guest)
        $('#delete_element').css('display', 'inline-block');
        this.plugin.Stop();
        Display.setTime(0);
        // Da aggiunmgere salvataggio currentTime su server
        this.currentTime = 0;
        if (this.stopCallback) {
            this.stopCallback();
        }
    } else {
        alert('Ignoring stop request, not in correct state');
    }
};

Player.resumeVideo = function() {
   Player.skipState=-1;
    alert("Resume");
    this.state = this.PLAYING;
    Main.itemLoadingHide();
   // if(Main.mode == Main.FULLSCREEN)
    $('#play').css('opacity', 0.4);
    $('#stop').css('opacity', 1.0);
    $('#pause').css('opacity', 1.0);
    $('#forward').css('opacity', 1.0);
    $('#rewind').css('opacity', 1.0);
    Display.status('Playing');
    this.plugin.Resume();
};

Player.skipForwardVideo = function() {
var diff=Display.totalTime-Player.cur_time;
 if (Player.cur_time <= 1000)
  return;
  if(diff <25000)
   return;
   Player.stop_cmd=1;
 this.skipState = this.FORWARD;
 this.plugin.JumpForward(25);    
  };

Player.skipBackwardVideo = function() {
 var diff=Display.totalTime-Player.cur_time;
 if (Player.cur_time <= 1000)
  return;
  Player.stop_cmd=1;
  this.skipState = this.REWIND;
    this.plugin.JumpBackward(25);
   };

Player.getState = function() {
    return this.state;
};

// Global functions called directly by the player 
Player.onBufferingStart = function() {
   if(Player.state == 0)
     return;
    clearInterval(Main.interval_buffer);
    Display.status(BUFFERING);
    Main.itemLoading();
     switch(this.skipState) {
        case this.FORWARD:
            $('#forward').css('opacity', 0.4);
            break;
        case this.REWIND:
            $('#rewind').css('opacity', 0.4);
            break;
    }
};
Player.onBufferingProgress = function(percent) {
     Display.status(BUFFERING + percent + '%');
};

Player.onBufferingComplete = function() {
    Player.stop_cmd=0;
     clearInterval(Main.interval_buffer);
    Main.itemLoadingHide();
     Display.status('Playing');
      switch(this.skipState) {
         case this.FORWARD:
            $('#forward').css('opacity', 1.0);
            Player.skipState=-1;
            break;
        case this.REWIND:
            $('#rewind').css('opacity', 1.0);
            Player.skipState=-1;
            break;
    }
};
Player.setCurTime = function(time) {
    clearInterval(Main.interval_buffer);
    Player.currentTime = time;
    Display.setTime(time);
    if (time == Display.totalTime) 
        Player.stopVideo();
    };
Player.setTotalTime = function() {
    Display.setTotalTime(Player.plugin.GetDuration());
};
Player.Error = function() {
    Server.dolog(Main.username_dec, 'ERROR', Data.videoURLs[Main.selectedVideo], Data.videoSource[Main.selectedVideo]);
    Player.stopVideo();
    alert('Stream not found');
};
onServerError = function() {
    Display.status('Server Error!');
};
OnNetworkDisconnected = function() {
    Display.status('Network Error!');
};

Player.count_waiting_buffer= function() {
    Main.cnt_for_buffer = Main.cnt_for_buffer + 1;
      if (Main.cnt_for_buffer > 10) {
        Main.cnt_for_buffer = 0;
        clearInterval(Main.interval_buffer);
        Player.stopVideo();
        Display.status(ERROR);
        Display.openPopup('buffer');
      }
};