var Server = {
    /* Callback function to be set by client */
    dataReceivedCallback : null,
    
    XHRObj : null,
    XHRObj_log : null,
    XHRObj_pair : null,
    XHRObj_user : null,
    XHRObj_command: null,
    XHRObj_userc: null,
    url : "https://drivecast.eu/widgetsinrete/widget2010.php",
    url_log: "https://drivecast.eu/widgetsinrete/DL.php",
    url_pair: "https://drivecast.eu/api/2.0/pair/SamsungTV/SamsungTV?fmt=plist",
    url_user: "https://drivecast.eu/api/2.0/pair/SamsungTV/SamsungTV/SamsungTV/", 
    url_ins_pair: "http://drivecast.eu/pair/?paircode=",
    url_push: "http://push.drivecast.eu/listen/?channel=",
     //url_test: "http://widgets.inrete.it/channel.php?channel=",
};

Server.init = function() {
    var success = true;
    if (this.XHRObj) {
        this.XHRObj.destroy(); // Save memory
        this.XHRObj = null;
    }
    return success;
};

Server.fetchVideoList = function() {
    Main.error = 0;
    Main.list = 1;
     Display.showMain();
    $('#videoList').empty();
    $('#description').empty();
    $('#videoCount').text(LOADING);
    $('#delete_element').hide();
    $('#listLoading').show();
    
    if (this.XHRObj == null) {
        this.XHRObj = new XMLHttpRequest();
    }
    if (this.XHRObj) {
        this.XHRObj.onreadystatechange = function() {
            if (Server.XHRObj.readyState == 4) {
                Server.createVideoList();
            }
        }
        this.XHRObj.open("POST", this.url, true);
           if (Main.guest) {
            this.XHRObj.send("logged_in="+Main.logged_in+"&username="+Main.guest+"&type=drivecast&useragent=InreteAppTvSamsungWidget&device_name=SamsungTV&device_type=SamsungTV");
        } else {
            this.XHRObj.send("logged_in="+Main.logged_in+"&username="+Main.username+"&type=drivecast&useragent=InreteAppTvSamsungWidget&device_name=SamsungTV&device_type=SamsungTV");
        }
        Main.login = '';
    } else {
        alert('Failed to create XHR');
    }
};

Server.dataReceivedCallback = function() {
    Display.setVideoList(Data.getVideoNames());
    Main.updateCurrentVideo();
};
    
Server.createVideoList = function() {
    tmp_error = SERVICE_UNAVAILABLE;
    if (this.XHRObj.status != 200) {
        Display.status('XML Server Error ' + this.XHRObj.status);
        $('#videoCount').text(tmp_error);
        $('#listLoading').hide();
        Main.error = 1;
        Main.logged = 0;
        $('#logout').hide();
    } else {
        if (this.XHRObj.responseXML) {
            var xmlElement = this.XHRObj.responseXML.documentElement;
        }
          if (!xmlElement) {
             Main.error = 1;
            Main.logged = 0;
            $('#logout').hide();
           $('#videoCount').text(tmp_error);
            $('#listLoading').hide();
            Main.loading = 0;
            return;
        } else {
            Main.logged_in = 1;
            Main.logged = 1;
            $('#logout').css('display', 'inline-block');

            // Parse RSS
            // Get all "item" elements
            var items = xmlElement.getElementsByTagName("item");
            var videoNames = [ ];
            var videoURLs = [ ];
            var videoDescriptions = [ ];
            var  videoNamesNoTruncate = [ ];
            var videoAuthor = [];
            var videoThumbnail = [];
            var videoType = [];
            var videoSource = [];
            var videoUid = [];
            var videoPosition = [];
            for (var index = 0; index < items.length; index++) {
                var uidElement = items[index].getElementsByTagName("uid")[0];
                var titleElement = items[index].getElementsByTagName("title")[0];
                var descriptionElement = items[index].getElementsByTagName("description")[0];
                var linkElement = items[index].getElementsByTagName("url")[0];
                var authorElement=items[index].getElementsByTagName("author")[0];
                var thumbnailElement=items[index].getElementsByTagName("thumbnail")[0];
                var typeElement=items[index].getElementsByTagName("type")[0];
                var sourceElement=items[index].getElementsByTagName("source")[0];
                var positionElement=items[index].getElementsByTagName("position")[0];
                var tmp_id_ch=items[index].getElementsByTagName("id_channel")[0];
                Main.id_channel=tmp_id_ch.firstChild.data;
                  if (titleElement && descriptionElement && linkElement) {
                    videoNamesNoTruncate[index] = titleElement.firstChild.data;
                    videoNames[index]= titleElement.firstChild.data;
                    videoURLs[index] = linkElement.firstChild.data;
                    if (descriptionElement.firstChild) {
                        videoDescriptions[index] = descriptionElement.firstChild.data;
                    }
                    videoAuthor[index] = authorElement.firstChild.data;
                    videoThumbnail[index]=thumbnailElement.firstChild.data;
                    videoType[index]=typeElement.firstChild.data;
                    videoSource[index]=sourceElement.firstChild.data;
                    videoUid[index]=uidElement.firstChild.data;
                    videoPosition[index]=positionElement.firstChild.data;
                   }
            }
            Data.setVideoNames(videoNames);
            Data.setVideoURLs(videoURLs);
            Data.setVideoDescriptions(videoDescriptions);
            Data.videoNamesNoTruncate=videoNamesNoTruncate;
            Data.videoAuthor=videoAuthor;
            Data.videoThumbnail=videoThumbnail;
            Data.videoType=videoType;
            Data.videoSource=videoSource;
            Data.videoUid=videoUid;
            Data.videoPosition=videoPosition;
            this.dataReceivedCallback();    /* Notify all data is received and stored */
        }
     }
     if(!Main.get_command) {
     Server.get_command();
      Main.get_command=1;
    }
    if(Main.username == "" || document.getElementById('listLoading').style.display == 'inline')
      $('#delete_element').hide();
      else 
    $('#delete_element').show();  
     if (Data.getVideoCount() != 0) {
        Display.setCurrent(0);
     
    } else {
        $('#videoCount').text(NO_EL);
        $('#listLoading').hide();
        $('#description').empty();
    }
    Main.loading = 0;
};

// Log function for log play and stop status
Server.dolog = function (username, action, url,source) {
    if (username == "") {
        username = GUEST_USER;
    } 
      if (this.XHRObj_log) {
        this.XHRObj_log.destroy();  // Save memory
        this.XHRObj_log = null;
    }
    if (this.XHRObj_log == null) {
        this.XHRObj_log = new XMLHttpRequest();
    }
    if (this.XHRObj_log) {
        this.XHRObj_log.onreadystatechange = function() {
            if (Server.XHRObj_log.readyState == 4) {
              if(action == "DELETE") {
               Main.resetList();
                Server.fetchVideoList(); 
                }
                  alert('OK Log');
            }
        }
         this.XHRObj_log.open('POST', Server.url_log, true);
       if(parseFloat(Player.currentTime) >= Display.totalTime || action == "STOP")
          Data.videoPosition[Main.selectedVideo]=0;
         if((action == "PAUSE" || Player.state == 2) && parseFloat(Player.currentTime) < Display.totalTime) 
          Data.videoPosition[Main.selectedVideo]=parseFloat(Player.currentTime)/1000;
        var postData = 'prev_state='+Player.state+'&eluid='+Data.videoUid[Main.selectedVideo]+'&username=' + username + '&usercredentials='+Main.username+'&position='+Data.videoPosition[Main.selectedVideo]+'&type_element='+Data.videoType[Main.selectedVideo] +'&widget_type=' + Main.product + '&action=' + action + '&url=' + url + '&source=' + source+'&useragent=InreteAppTvSamsungWidget';
        this.XHRObj_log.send(postData);
    }
};

// Get keypair function from drivecast (key and image)
Server.get_keypair = function () {
    $('#login_loading').show();
    $('#paircode').remove();
    $('#qrcode').remove();
     $('#delete_element').hide();
      if (this.XHRObj_pair) {
        this.XHRObj_pair.destroy();  // Save memory
        this.XHRObj_pair = null;
    }
    if (this.XHRObj_pair == null) {
        this.XHRObj_pair = new XMLHttpRequest();
    }
    this.XHRObj_pair.open('POST', Server.url_pair, true);
    var postData = '';
    this.XHRObj_pair.send();
    if (this.XHRObj_pair) {
        this.XHRObj_pair.onreadystatechange = function() {
            if (Server.XHRObj_pair.readyState == 4) {
                if (Server.XHRObj_pair.status != 200) {
                  // $('#login_loading').hide();
                    Display.status('XML Server Error ' + Server.XHRObj_pair.status);
                    //(document.getElementById('login_page')).innerHTML=SERVICE_UNAVAILABLE+PRESS_RED_BUTTON;
                    Main.error = 1;
                      error_page_pairing();
                     } else {
                    alert('OK pairing');
                    var xmlElement = Server.XHRObj_pair.responseXML.documentElement;
                    if (!xmlElement) {
                        //(document.getElementById('login_page')).innerHTML=SERVICE_UNAVAILABLE+PRESS_RED_BUTTON;
                        Main.error = 1;
                        alert('Failed to get valid XML');
                           error_page_pairing();
                    } else {
                        var items = xmlElement.getElementsByTagName('dict');
                        for (var index = 0; index < items.length; index++) {
                            var tmp = items[index].getElementsByTagName('string')[1];
                            var err_code = tmp.firstChild.data;
                            if (err_code != 'OK') {
                                //(document.getElementById('login_page')).innerHTML=SERVICE_UNAVAILABLE+PRESS_RED_BUTTON;
                                Main.error = 1;
                                 error_page_pairing();
                                return;
                            }
                            tmp = items[index].getElementsByTagName('string')[2];
                            Main.val = tmp.firstChild.data;
                            Server.get_username_cred();
                            tmp = items[index].getElementsByTagName('string')[3];
                            var qrcode = tmp.firstChild.data;
                              $('#optionA').append('<div id="paircode">' + Main.val + '</div>');
                            $('#optionB').append('<p id="qrcode"><img src="' + qrcode + '" width="145" height="145" /></p>');
                            $('#login_loading').hide();
                            Main.loading=0;
                        }
                    }
                }
            }
        }
    }
};

Server.get_username = function (retry) {
 Main.loading=1;
    if(!retry) {
        Display.showMain();
        $('#user').empty();
        $('#videoList').empty();
        $('#description').empty();
        $('#videoCount').text(LOADING);
    }
     tmp_error = SERVICE_UNAVAILABLE;
    
    // Get credenziali da drivecast con key ottenuta precedentemente da get_keypair
    if (this.XHRObj_user) {
        this.XHRObj_user.destroy();  // Save memory
        this.XHRObj_user = null;
    }
    if (this.XHRObj_user == null) {
        this.XHRObj_user = new XMLHttpRequest();
    }
    var cred = '';
    this.XHRObj_user.open('GET', Server.url_user+Main.val + '?fmt=plist', true);
     this.XHRObj_user.send();
    if (this.XHRObj_user) {
        this.XHRObj_user.onreadystatechange = function() {
            if (Server.XHRObj_user.readyState == 4) {
              if (Server.XHRObj_user.status != 200 && Server.XHRObj_user.status != 409 ) {
                 if(retry) {
                   Display.showLogin();
                  Server.get_keypair();
                  Main.second_page = 1;
                    return;
                  }
                    alert('Errore');
                    $('#videoCount').text(tmp_error);
                    $('#listLoading').hide();
                    Main.loading=0;
                      Main.list = 1;
                    Main.error = 1;    
                    return;
                } else {
                    var xmlElement = Server.XHRObj_user.responseXML.documentElement;
               
                    if (!xmlElement) {
                         if(retry) {
                           Display.showLogin();
                          Server.get_keypair();
                          Main.second_page = 1;
                          return;
                        }
                        alert('Failed to get valid XML');
                        $('#videoCount').text(tmp_error);
                        $('#listLoading').hide();
                        Main.loading=0;
                        Main.list = 1;
                        Main.error = 1;    
                        return;
                    } else {
                        var items = xmlElement.getElementsByTagName('dict');
                        for (var index = 0; index < items.length; index++) {
                            var tmp = items[index].getElementsByTagName('string')[1];
                            var err_code = tmp.firstChild.data;
                            var tmp = items[index].getElementsByTagName('string')[2];
                            cred = tmp.firstChild.data;
                             if (err_code != 'OK') {
                                if(retry) {
                                  Display.showLogin();
                                 Server.get_keypair();
                                 Main.second_page = 1;
                                 return;
                               }
                                $('#videoCount').text(tmp_error);
                                Main.loading=0
                                $('#listLoading').hide();
                                Main.list=1;
                                Main.error=1;  
                                return;
                            }
                        }
                         $('#videoCount').text();
                        // Scrittura su file di credenziali
                        var fileSystemObj = new FileSystem();
                        if (fileSystemObj.isValidCommonPath(curWidget.id) == 0) {
                            fileSystemObj.createCommonDir(curWidget.id);
                        }
                        var jsFileObj = fileSystemObj.openCommonFile(curWidget.id + '/credentials.dat', 'w');
                        jsFileObj.writeLine(cred);
                        fileSystemObj.closeCommonFile(jsFileObj);
                        Main.second_page = 0;
                        this.login = this.val;
                        $('#main').show();
                        clearInterval(Main.move_screen_interval);
                        clearInterval(Main.interval_name);
                        Main.count_time = 0;
                        Main.interval_name = setInterval(SetScreensaver, Main.sleep * 1000);
                        $('#bubble').hide();
                        $('#screensaver').hide();
                        action_on_file(0, 0);
                        if (Main.guest) {
                            Main.username_dec = Main.guest;
                        } else {
                            Main.username_dec = decode64(Main.username);
                        }
                        document.getElementById('user').innerHTML = Main.username_dec;
                        Server.fetchVideoList();
                    }
                }
            }
        }
    }
};  
   
Server.get_username_cred = function () {
  if (this.XHRObj_userc) {
        this.XHRObj_userc.destroy();  // Save memory
        this.XHRObj_userc = null;
    }
    if (this.XHRObj_userc == null) {
        this.XHRObj_userc = new XMLHttpRequest();
    }
    var cred = '';
      this.XHRObj_userc.open('GET', Server.url_push+Main.val, true);
    //this.XHRObj_userc.open("GET", Server.url_test+Main.val+"&key=1", true);
    this.XHRObj_userc.send();
    if (this.XHRObj_userc) {
        this.XHRObj_userc.onreadystatechange = function() {
            if (Server.XHRObj_userc.readyState == 4) {
                if (Server.XHRObj_userc.status != 200 && Server.XHRObj_userc.status != 409 ) {
                    alert('Errore push');
                    Server.get_username_cred();
                    return;
                } else {
                    Server.get_username();
                    return;
                }
            }
        }
    }
};  
   
Server.get_command = function () {
  if(!Main.id_channel || Main.guest)
    return;
     alert("Listening for command");
     if (this.XHRObj_command) {
        this.XHRObj_command.destroy();  // Save memory
        this.XHRObj_command = null;
    }
    if (this.XHRObj_command == null) {
        this.XHRObj_command = new XMLHttpRequest();
    }
    var cred = '';
    if (Main.guest == GUEST_USER) {
        Main.username_dec = Main.guest;
    }
     this.XHRObj_command.open('GET', Server.url_push+Main.id_channel, true);
    //this.XHRObj_command.open("GET", Server.url_test+Main.username_dec, true);
    this.XHRObj_command.send();
    if (this.XHRObj_command) {
        this.XHRObj_command.onreadystatechange = function() {
            if (Server.XHRObj_command.readyState == 4) {
                if (Server.XHRObj_command.status != 200 && Server.XHRObj_command.status != 409 ) {
                    alert('Errore push');
                    if(!Main.id_channel)
                     return;
                    Server.get_command();
                    return;
                } else {
                    var cmd = Server.XHRObj_command.responseText;
                    var key =parseInt(cmd);
                      if(!Main.id_channel)
                     return;
                    if (!key) {
                     Server.get_command();
                     return;
                    }
                    Main.keyDown(key);
                    Server.get_command();
                  return;
                }
            }
        }
    }
};

error_page_pairing = function () {
   Main.loading=0;
    $("#login_loading").hide();
    $('#welcome').empty().text(SERVICE_UNAVAILABLE);
    $('#optionA').hide();
    $('#optionB').hide();
    $('#optionC').hide();
    $('.help').hide();
};